// This code belongs to Kurioos iTech.
//
// You have only the rights to install and use it with WoozTalk Instant
// Messenger. You are not allowed to distribute it, as is or updated.
// However, if you want to improve it or make derivative works, you are welcome
// to contact us and send us your suggestions (and your code). If we like them,
// we may include your ideas in the next update and you will be credited for
// them.
//
// I apologize for the quality of this code ... I don't like very much
// javascript and XUL ...... :-p

var undefined; // Just in case ...

var FirefoxOnWoozTalk = {
    gSites : new Array(),
    nbrTab : 1,
    connection_status : -1,  // 0 : no client available, 1 : client available but not connected, 2 : client connected
    bundle : undefined,
    wooztalkPrefs : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),
    osString : Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS,  
    isActive : false,
    MY_EXTENSION_UUID : "firefoxonwooztalk@wooztalk.com",
    onlyOneURL : "",
    hasBeenLoaded : false,
    id_timeout : undefined,


run_extension : function() {
    var onToolbarButtonCommand = function(e) {
	var stat = document.getElementById('firefoxonwooztalk-status');
	stat.collapsed = true;

	LOG("onToolbarButtonCommand START");
	if (FirefoxOnWoozTalk.isActive) {
	    disableExtension();
	    alert(getBundleString("extension.disabled"));
	} else {
	    enableExtension();
	    launch_wooztalk();
	}
	LOG("onToolbarButtonCommand END");
    };


    var HasToSendURL = function() {
	if (FirefoxOnWoozTalk.wooztalkPrefs.getPrefType("wooztalkonfirefox.enabled") != 
		FirefoxOnWoozTalk.wooztalkPrefs.PREF_BOOL) {
	    FirefoxOnWoozTalk.wooztalkPrefs.setBoolPref("wooztalkonfirefox.enabled", true);
	    return true;
	} else {
	    return FirefoxOnWoozTalk.wooztalkPrefs.getBoolPref("wooztalkonfirefox.enabled");
	}
    };

    var get_exe_path = function() {
	var myid = FirefoxOnWoozTalk.MY_EXTENSION_UUID;
	var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	var file = em.getInstallLocation(myid).getItemFile(myid, "wooztalk");
	return file.path;
    };

    var get_exe = function() {
	if (FirefoxOnWoozTalk.osString == "WINNT") {
	    return get_exe_path()+"\\wooztalk.exe";
	} else {
	    var myid = FirefoxOnWoozTalk.MY_EXTENSION_UUID;
	    var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	    var file = em.getInstallLocation(myid).getItemFile(myid, "wooztalk/wooztalk");
	    return file.path;
	}
    };

    var check_exe = function() {
	var file = Components.classes["@mozilla.org/file/local;1"]
	    .createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(get_exe());
	if (!file.exists()) {
	    return 0;
	} else {
	    file = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	    if (FirefoxOnWoozTalk.osString == "WINNT") {
		file.initWithPath(get_exe_path()+"\\wooztalk.pem");
	    } else {
		file.initWithPath(get_exe_path()+"/wooztalk.pem");
	    }
	    if (!file.exists()) {
		return 0;
	    } else {
		return 1;
	    }
	}
    };

    var SetHasToSendURL = function(st) {
	LOG("SetHasToSendURL START "+st);
	FirefoxOnWoozTalk.wooztalkPrefs.setBoolPref("wooztalkonfirefox.enabled", st);
	LOG("SetHasToSendURL END");
    };

    var countWindows = function() {
	LOG("countWindows START");
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
	    .getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator("navigator:browser");
	var counter = 0;
	LOG("Count !");
	while(enumerator.hasMoreElements()) {
	    var win = enumerator.getNext();
	    counter = counter + 1;
	}
	LOG("countWindows END");
	return counter;
    };

    var LOG = function(msg) {
/*	var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
	    .getService(Components.interfaces.nsIConsoleService);
	consoleService.logStringMessage(msg);
	*/
    };

    /* Get string according to locale */
    var getBundleString = function(key) {
	if (FirefoxOnWoozTalk.bundle == undefined) {
	    FirefoxOnWoozTalk.bundle = document.getElementById("firefoxonwooztalk-strings");
	    if (FirefoxOnWoozTalk.bundle == undefined) {
		return "";
	    } else {
		return FirefoxOnWoozTalk.bundle.getString(key);
	    }
	} else {
	    return FirefoxOnWoozTalk.bundle.getString(key);
	}
    };

    /* Store old site for a tab */
    var setOldSiteURL = function(where, url) {
	LOG("setOldSiteURL");
	//alert("setOldSiteURL : "+url);
	if (FirefoxOnWoozTalk.nbrTab == 1) {
	    FirefoxOnWoozTalk.onlyOneURL = url;
	} else {
	    where.setAttribute("firefoxonwooztalk-old-site", url);
	}

	if (url != "") {
	    enableTimeout(where, url);
	}
    };

    var enableTimeout = function(where, url) {
	var id_timeout = setTimeout(function () { sendCloseURL(url, false); }, 10*1000);
	if (FirefoxOnWoozTalk.nbrTab == 1) {
	    FirefoxOnWoozTalk.id_timeout = id_timeout;
	} else {
	    where.setAttribute("firefoxonwooztalk-id-timeout", id_timeout);
	}
    };

    var disableTimeout = function(where) {
	if (FirefoxOnWoozTalk.nbrTab == 1) {
	    clearTimeout(FirefoxOnWoozTalk.id_timeout);
	} else {
	    clearTimeout(where.getAttribute("firefoxonwooztalk-id-timeout"));
	}
    };

    /* Get old site for a tab */
    var getOldSiteURL = function(where) {
	LOG("getOldSiteURL");
	if (FirefoxOnWoozTalk.nbrTab == 1) {
	    return FirefoxOnWoozTalk.onlyOneURL;
	} else {
	    try {
		return where.getAttribute("firefoxonwooztalk-old-site");
	    } catch (e) {
		return "";
	    }
	}
    };

    var setHasBeenLoaded = function(where, st) {
	if (FirefoxOnWoozTalk.nbrTab == 1) {
	    FirefoxOnWoozTalk.hasBeenLoaded = st;
	} else {
	    where.setAttribute("firefoxonwooztalk-loaded", st);
	}
    };

    var getHasBeenLoaded = function(where) {
	if (FirefoxOnWoozTalk.nbrTab == 1) {
	    return FirefoxOnWoozTalk.hasBeenLoaded;
	} else {
	    try {
		return where.getAttribute("firefoxonwooztalk-loaded");
	    } catch (e) {
		//alert(e);
		return false;
	    }
	}
    };

    /* Verify an URL and returns the one to use (empty string if this URL is not allowed) */
    var verifyURL = function(url) {
	try {
	    LOG("Verif ("+url+") : "+url.host+" / "+url.host.indexOf("localhost")
		    + " / "+url.port+" / "+url.host.indexOf(":"));
	    if (url.port != undefined && url.port != -1  && url.port != ""
		    && url.host.indexOf(":") == -1) {
		port = ":"+url.port
	    } else {
		port = "";
	    }

	    if (url.scheme != undefined) {
		if (url.scheme == "http" || url.scheme == "https" || url.scheme == "ftp") {
		    return "http://"+url.host+port;
		} else {
		    return "";
		}
	    } else if (url.protocol != undefined) {
		if (url.protocol == "https:" || url.protocol == "http:" || url.protocol == "ftp:") {
		    return "http://"+url.host+port;
		} else {
		    return "";
		}
	    } else {
		LOG("Undefined scheme and protocol");
		return "";
	    }
	} catch (e) {
	    LOG("Exception triggered");
	    return "";
	    //	return url.scheme+"://"+url.host;
	}
    };

    /* Close all sites for current window */
    var closeAllSites = function(sync) {
	var num = getBrowser().browsers.length;
	for (var i = 0; i < num; i++) {
	    var b = getBrowser().getBrowserAtIndex(i);
	    try {
		url = verifyURL(b.currentURI);
		LOG(url);
		if (url != "") {
		    sendCloseURL(url, sync);
		}
	    } catch(e) {
		Components.utils.reportError(e);
	    }
	}
    };

    /* Open all sites for current window */
    var openAllSites = function() {
	var num = getBrowser().browsers.length;
	for (var i = 0; i < num; i++) {
	    LOG("Browser "+i);
	    var b = getBrowser().getBrowserAtIndex(i);
	    try {
		url = verifyURL(b.currentURI);
		LOG(url);
		if (url != "") {
		    sendOpenURL(url);
		}
	    } catch(e) {
		Components.utils.reportError(e);
	    }
	}
    };

    var enableExtension = function() {
	if (FirefoxOnWoozTalk.isActive) {
	    // Nothing to do
	    return ;
	} else {
	    FirefoxOnWoozTalk.isActive = true;
	    SetHasToSendURL(FirefoxOnWoozTalk.isActive);
	    updateText(getBundleString("enabled"));

	    var button = document.getElementById('firefoxonwooztalk-button');
	    var statbutton = document.getElementById('firefoxonwooztalk-statusbar-button');

	    statbutton.setAttribute('src', "chrome://firefoxonwooztalk/skin/enabled.ico");
	    button.removeAttribute('mode');
	    button.setAttribute('tooltiptext', getBundleString("status.disable"));
	    openAllSites();
	}
    };

    var disableExtension = function() {
	if (!FirefoxOnWoozTalk.isActive) {
	    // Nothing to do
	    return ;
	} else {
	    updateText(getBundleString("disabled"));

	    var button = document.getElementById('firefoxonwooztalk-button');
	    var statbutton = document.getElementById('firefoxonwooztalk-statusbar-button');

	    statbutton.setAttribute('src', "chrome://firefoxonwooztalk/skin/disabled.ico");
	    button.setAttribute('mode', 'disabled');
	    button.setAttribute('tooltiptext', getBundleString("status.enable"));
	    closeAllSites(false);
	    FirefoxOnWoozTalk.isActive = false;
	    SetHasToSendURL(FirefoxOnWoozTalk.isActive);

	    /*
		var stat = document.getElementById('firefoxonwooztalk-status');
		stat.collapsed = true;
		*/
	}
    };

    var addButtons = function() {
	LOG("addButtons ENTER");
	var navBar = document.getElementById("nav-bar");
	var newSet = "";
	var buttonsExist = false;

	// Check if buttons exist
	for(var k = 0; k < navBar.childNodes.length; k++) {
	    if(navBar.childNodes[k].id == "firefoxonwooztalk-button") {
		buttonsExist = true;
	    }
	}

	for(var k = 0; k < navBar.childNodes.length; k++) {
	    if(navBar.childNodes[k].id == "firefoxonwooztalk-button") {
		navBar.removeChild(navBar.childNodes[k]);
		k--;
	    }
	}

	for(var k = 0; k < navBar.childNodes.length; k++) {
	    if(navBar.childNodes[k].id == "urlbar-container") {
		newSet += "firefoxonwooztalk-button,";
	    }
	    newSet += navBar.childNodes[k].id + ",";
	}

	newSet = newSet.substring(0, newSet.length - 1);
	navBar.currentSet = newSet;
	navBar.setAttribute("currentset", newSet);
	document.persist(navBar.id, "currentset");

	LOG("Init");
	var button = document.getElementById('firefoxonwooztalk-button');
	var statbutton = document.getElementById('firefoxonwooztalk-statusbar-button');
	var nbr = document.getElementById('firefoxonwooztalk-statusbar-nbr');

	if (FirefoxOnWoozTalk.isActive) {
	    updateText(getBundleString("enabled"));
	    statbutton.setAttribute('src', "chrome://firefoxonwooztalk/skin/enabled.ico");
	    button.removeAttribute('mode');
	    button.setAttribute('tooltiptext', getBundleString("status.disable"));
	} else {
	    updateText(getBundleString("disabled"));
	    statbutton.setAttribute('src', "chrome://firefoxonwooztalk/skin/disabled.ico");
	    button.setAttribute('mode', 'disabled');
	    button.setAttribute('tooltiptext', getBundleString("status.enable"));
	}

	button.addEventListener("command", onToolbarButtonCommand, false);

	LOG("Customize done");
	try {
	    BrowserToolboxCustomizeDone(true);
	} catch (e) {
	}

	LOG("Leave");
    };

    var callInProgress = function(xmlhttp) {
	switch (xmlhttp.readyState) {
	    case 1, 2, 3:
		return true;
		break;
		// Case 4 and 0
	    default:
		return false;
		break;
	}
    };

    var sendOpenURL = function(url) {
	if (!FirefoxOnWoozTalk.isActive) {
	    LOG("EXTENSION IS NOT ACTIVE");
	    return ;
	}

	url = url.toLowerCase();
	var p = new XMLHttpRequest();
	var timeoutId = window.setTimeout( function() { if (callInProgress(p)) { p.abort(); } }, 5000);
	p.onreadystatechange = function() {
	    try {
		if (this.readyState == 4) {
		    if (this.responseXML == null) {
			FirefoxOnWoozTalk.gSites[url] = -2;
		    } else {
			var mainNode = p.responseXML.documentElement;
			FirefoxOnWoozTalk.gSites[url] = mainNode.getAttribute("users");
		    }
		    updateNbr(url);
		}
	    } catch (e) { LOG("Exception open: "+e); }
	};
	p.onerror = function(e) {
	    if (callInProgress(this)) {
		this.abort();
		LOG("oooooooooo Request aborted : "+url);
	    }
	    FirefoxOnWoozTalk.connection_status = 0;
	}
	p.open("GET", "http://localhost:6788/firefox/open/"+url, true);
	p.send(null);
    };

    var sendCloseURL = function(url, sync) {
	if (!FirefoxOnWoozTalk.isActive) {
	    LOG("EXTENSION IS NOT ACTIVE");
	    return ;
	}

	try {
	    url = url.toLowerCase();
	    LOG("********** CLOSE_URL : "+url);
	    var p = new XMLHttpRequest();
	    var timeoutId = window.setTimeout( function() { if (callInProgress(p)) { p.abort(); } }, 5000);
	    if (!sync) {
		p.onreadystatechange = function() { 
		    try {
			if (this.readyState == 4) {
			    //alert("Close sent : "+url);
			}
		    } catch (e) { LOG("Exception open: "+e); }
		};
		p.onerror = function(e) {
		    //alert("Error :"+url);
		    if (callInProgress(p)) {
			p.abort();
		    }
		    FirefoxOnWoozTalk.connection_status = 0;
		}
	    }
	    p.open("GET", "http://localhost:6788/firefox/close/"+url, !sync);
	    p.send(null);
	} catch (e) {
	    LOG("Exception in close");
	}
    };

    var sendAskURL = function(url) {
	if (!FirefoxOnWoozTalk.isActive) {
	    LOG("EXTENSION IS NOT ACTIVE");
	    return ;
	}

	url = url.toLowerCase();
	LOG("********** ASK_URL : "+url);
	var p = new XMLHttpRequest();
	var timeoutId = window.setTimeout(
		function() {
		if (callInProgress(p)) {
		p.abort();
		LOG("oooooooooo Request aborted : "+url);
		FirefoxOnWoozTalk.gSites[url] = -2;
		}
		},
		1000 // One second
		);
	p.onreadystatechange = function() {
	    LOG("========== ASK_URL ("+url+") : " +p.readyState);
	    if(p.readyState == 4) {
		if (p.responseXML == null) {
		    FirefoxOnWoozTalk.gSites[url] = -2;
		} else {
		    var mainNode = p.responseXML.documentElement;
		    FirefoxOnWoozTalk.gSites[url] = mainNode.getAttribute("users");
		}
		updateNbr(url);
	    }
	};
	p.onerror = function(e) {
	    if (callInProgress(p)) {
		p.abort();
		LOG("oooooooooo Request aborted : "+url);
	    }
	    FirefoxOnWoozTalk.connection_status = 0;
	}
	p.open("GET", "http://localhost:6788/firefox/ask/"+url, true);
	p.send(null);
    };

    /* Update nbr displayed in status bar for an URL */
    var updateNbr = function(url) {
	var currentHost =
	    verifyURL(getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex).currentURI);

	LOG("UPDATE : "+url+"/"+currentHost);
	var nbr = document.getElementById('firefoxonwooztalk-statusbar-nbr');
	if (FirefoxOnWoozTalk.isActive == false) {
	    nbr.value = getBundleString("disabled");
	} else if (url == currentHost) {
	    LOG("UPDATE : "+url+"<="+FirefoxOnWoozTalk.gSites[url]);
	    if (FirefoxOnWoozTalk.connection_status == 0) {
		nbr.value =  getBundleString("notreachable");
	    } else if (FirefoxOnWoozTalk.connection_status == 1) {
		nbr.value =  getBundleString("clientnotconnected");
	    } else if (FirefoxOnWoozTalk.gSites[url] == undefined) {
		nbr.value =  getBundleString("noinfo");
	    } else if (FirefoxOnWoozTalk.gSites[url] == -2) {
		nbr.value =  getBundleString("notreachable");
	    } else if (FirefoxOnWoozTalk.gSites[url] == -10) {
		nbr.value = getBundleString("forbidden");
	    } else if (FirefoxOnWoozTalk.gSites[url] == -11) {
		nbr.value = getBundleString("blocked");
	    } else if (FirefoxOnWoozTalk.gSites[url] == -12) {
		nbr.value = getBundleString("noforlocal");
	    } else if (FirefoxOnWoozTalk.gSites[url] == 0) {
		nbr.value = getBundleString("nobody");
	    } else if (FirefoxOnWoozTalk.gSites[url] == 1) {
		nbr.value = FirefoxOnWoozTalk.gSites[url]+" "+getBundleString("wooztalker");
	    } else {
		nbr.value = FirefoxOnWoozTalk.gSites[url]+" "+getBundleString("wooztalkers");
	    }
	}
    };

    var updateText = function(txt) {
	var nbr = document.getElementById('firefoxonwooztalk-statusbar-nbr');
	if (nbr != undefined) {
	    nbr.value = txt;
	}
    };

    var tabAdded = function(event) {
	LOG("Tab added");
	if (FirefoxOnWoozTalk.nbrTab == 1) {
	    var fbrowser = getBrowser().getBrowserAtIndex(0);
	    fbrowser.addEventListener("pagehide", examplePageUnload, true);
	    fbrowser.addEventListener("pageshow", examplePageLoad, true);
	    //fbrowser.addEventListener("DOMContentLoaded", examplePageLoad, false);
	}
	FirefoxOnWoozTalk.nbrTab++;

	var browser = event.target.linkedBrowser;
	browser.addEventListener("pagehide", examplePageUnload, true);
	browser.addEventListener("pageshow", examplePageLoad, true);
	//browser.addEventListener("DOMContentLoaded", examplePageLoad, true);
    };

    var tabRemoved = function(event) {
	var browser = event.target.linkedBrowser;
	LOG("Tab removed : "+browser.currentURI);
	FirefoxOnWoozTalk.nbrTab--;

	browser.removeEventListener("pagehide", examplePageUnload, true);
	browser.removeEventListener("pageshow", examplePageLoad, true);
	//browser.removeEventListener("DOMContentLoaded", examplePageLoad, true);

	var url = verifyURL(browser.currentURI);
	if (url=="") {
	    return ;
	}

	LOG("Tab removed : "+url);
	sendCloseURL(url, false);
    };

    var tabSelected = function(event) {
	LOG("Tab Selected");
	var browser = event.target.linkedBrowser;
	LOG("Tab Selected 2");
	if (browser.currentURI) {
	    var url = verifyURL(browser.currentURI);
	    if (url=="") {
		updateText(getBundleString("noinfo"));
		LOG("Tab Selected (end1)");
		return ;
	    }

	    LOG("Sélection : "+url);
	    updateNbr(url);
	    if (getHasBeenLoaded(browser)) {
		sendAskURL(url);
	    }
	}
	LOG("Tab Selected (end)");
    };

    var examplePageUnload = function(event) {
	LOG("examplePageUnload");
	var doc = event.originalTarget;
	if (doc == null || doc.nodeName != "#document" || doc.location == null) {
	} else {
	//if (event.originalTarget instanceof HTMLDocument) {
	    if (doc.defaultView.frameElement) {
		return;
	    }

	    if (!getHasBeenLoaded(this)) {
		return ;
	    } else {
		setHasBeenLoaded(this, false);
	    }

	    if (doc.location == "about:blank") {
		setHasBeenLoaded(this, false);
		setOldSiteURL(this, "");
		return ;
	    }
	    var url = verifyURL(doc.location);
	    LOG("examplePageUnload:"+url);
	    if (url=="") {
		setHasBeenLoaded(this, false);
		setOldSiteURL(this, "");
		return ;
	    }

	    // Store old site
	    LOG("Page quittée : "+url);
	    setOldSiteURL(this, url);
	    LOG("Enregistré : "+getOldSiteURL(this));
	}
    };

    var examplePageLoad = function(event) {
	LOG("examplePageLoad");
	//if (event.originalTarget instanceof HTMLDocument) {
	var doc = event.originalTarget;
	if (doc == null || doc.nodeName != "#document" || doc.location == null) {
	} else {
	    if (doc.defaultView.frameElement) {
		return;
	    }
	    if (doc.location == "about:blank") {
		return ;
	    }

	    var url = verifyURL(doc.location);
	    LOG("examplePageLoad : "+url);
	    var oldURL = getOldSiteURL(this);
	    disableTimeout(this);

	    // Same site, nothing to do
	    if (oldURL == url) {
		LOG("On reste sur le même site");
	    } else { // Close old site and send new one
		if (oldURL != "") {
		    sendCloseURL(oldURL, false);
		}
		sendOpenURL(url);
	    }

	    if (url != "") {
		setHasBeenLoaded(this, true);
	    } else {
		setHasBeenLoaded(this, false);
	    }
	    //alert("loaded : "+url+" <- "+getHasBeenLoaded(this));
	}
    };

    /* Check if client is available and connected */
    var check_wooztalk_client_status = function() {
	LOG("********** Check");
	var p = new XMLHttpRequest();
	var timeoutId = window.setTimeout( function() {
		LOG("oooooooooo CHECK: timeout");
		if (callInProgress(p)) {
		p.abort();
		FirefoxOnWoozTalk.connection_status = 0;
		updateText(getBundleString("notreachable"));
		LOG("CHECK: again (timeout)");
		window.setTimeout(check_wooztalk_client_status, 10000);
		}
		}, 1000);
	p.onreadystatechange = function() {
	    LOG("========== CHECK state "+p.readyState);
	    if(p.readyState == 4) {
		if (p.responseXML == null) {
		    if (FirefoxOnWoozTalk.connection_status != 0) {
			FirefoxOnWoozTalk.connection_status = 0;
			updateText(getBundleString("notreachable"));
		    }
		} else {
		    LOG("isActive="+FirefoxOnWoozTalk.isActive+"  connection_status="+FirefoxOnWoozTalk.connection_status);
		    if (FirefoxOnWoozTalk.isActive && FirefoxOnWoozTalk.connection_status == 0) {
			openAllSites();
		    }
		    var mainNode = p.responseXML.documentElement;
		    if (mainNode.getAttribute("connected") == "1") {
			if (FirefoxOnWoozTalk.connection_status != 2) {
			    updateText(getBundleString("reachable"));
			    FirefoxOnWoozTalk.connection_status = 2;
			}
		    } else {
			if (FirefoxOnWoozTalk.connection_status != 1) {
			    updateText(getBundleString("clientnotconnected"));
			    FirefoxOnWoozTalk.connection_status = 1;
			}
		    }
		}
		LOG("CHECK: again (normal)");
		clearTimeout(timeoutId);
		window.setTimeout(check_wooztalk_client_status, 10000);
	    }
	};
	p.open("GET", "http://localhost:6788/firefox/check/", true);
	p.send(null);
    };

    var unregister_wooztalk = function() {
	var p = new XMLHttpRequest();
	p.open("GET", "http://localhost:6788/firefox/quit/", false);
	p.send(null);
    };

    var install_wooztalk = function(exe_path) {
	var myid = FirefoxOnWoozTalk.MY_EXTENSION_UUID;
	var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	var file = em.getInstallLocation(myid).getItemFile(myid, "wooztalk_install.exe");

	if (!file.exists()) {
	    return ;
	}

	// create an nsIProcess
	var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
	process.init(file);

	// Run the process in background (false)
	var param = "/S /NOXPI /D=" + exe_path;
	var args = (param.split(' '));
	process.run(false, args, args.length);

	window.setTimeout( function() { window._content.document.location = "http://www.wooztalk.com/download/install_ok.php"; }, 2000);
    };

    var launch_wooztalk = function(exe_path) {
	if (check_exe()) {
	    var file1 = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	    file1.initWithPath(get_exe());
	    // create an nsIProcess
	    var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
	    process.init(file1);

	    // Run the process in background (false)
	    //var args = [exe_path];
	    LOG("Launch WoozTalk process");
	    var args = ["SILENT"];
	    process.run(false, args, args.length);

	    return 1;
	} else if (osString == "WINNT") {
	    var file1 = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	    file1.initWithPath("wooztalk.exe");
	    // create an nsIProcess
	    var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
	    process.init(file1);

	    // Run the process in background (false)
	    //var args = [exe_path];
	    LOG("Launch WoozTalk process");
	    var args = ["SILENT"];
	    process.run(false, args, args.length);
	} else {
	    var file = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	    file.initWithPath("/usr/bin/wooztalk");
	    if (!file.exists()) {
		file.initWithPath("/usr/local/bin/wooztalk");
		if (!file.exists()) {
		    file.initWithPath("/opt/bin/wooztalk");
		    if (!file.exists()) {
			return 0;
		    }
		}
	    }

	    var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
	    process.init(file);

	    // Run the process in background (false)
	    //var args = [exe_path];
	    LOG("Launch WoozTalk process");
	    var args = ["SILENT"];
	    process.run(false, args, args.length);

	    return 1;
	}
    };

    var uninstall_wooztalk = function() {
	alert(getBundleString("uninstallmsg"));

	var exe_path = get_exe_path();
	var file = Components.classes["@mozilla.org/file/local;1"]
	    .createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(exe_path+"\\uninstall.exe");
	if (file.exists()) {
	    // create an nsIProcess
	    var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
	    process.init(file);

	    // Run the process in background (false)
	    var param = "/S /NOXPI";
	    var args = (param.split(' '));
	    process.run(true, args, args.length);
	}
    };

    var initializeOverlay = function() {
	UninstallObserver.register();
    };

    var UninstallObserver = {
_uninstall : false,
	     observe : function(subject, topic, data) {
		 if (topic == "em-action-requested") {
		     subject.QueryInterface(Components.interfaces.nsIUpdateItem);

		     if (subject.id == FirefoxOnWoozTalk.MY_EXTENSION_UUID) {
			 if (data == "item-uninstalled") {
			     this._uninstall = true;
			 } else if (data == "item-cancel-action") {
			     this._uninstall = false;
			 }
		     }
		 } else if (topic == "quit-application-granted") {
		     if (this._uninstall) {
			 uninstall_wooztalk();
		     }
		     this.unregister();
		 }
	     },
register : function() {
	       var observerService =
		   Components.classes["@mozilla.org/observer-service;1"].
		   getService(Components.interfaces.nsIObserverService);

	       observerService.addObserver(this, "em-action-requested", false);
	       observerService.addObserver(this, "quit-application-granted", false);
	   },
unregister : function() {
		 var observerService =
		     Components.classes["@mozilla.org/observer-service;1"].
		     getService(Components.interfaces.nsIObserverService);

		 observerService.removeObserver(this,"em-action-requested");
		 observerService.removeObserver(this,"quit-application-granted");
	     }
	};

    var main = function(event) {
	window.removeEventListener("load", main, false);

	if (countWindows() == 1) {
	    initializeOverlay();

	    try {
		var exe_path = get_exe_path();
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(exe_path);
		if (file.exists()) {
		    if (launch_wooztalk(exe_path) == 0) {
			install_wooztalk(exe_path);
		    }
		} else {
		    install_wooztalk(exe_path);
		}
	    } catch (e) {
		//alert(e);
	    }
	}
	return false;
    };

    window.addEventListener("load", main, false);
    if (countWindows() == 1) {
	FirefoxOnWoozTalk.isActive = HasToSendURL();
	check_wooztalk_client_status();
    }

    window.addEventListener("pageshow",
	    function (event) {
	    if (FirefoxOnWoozTalk.nbrTab == 1) {
	    LOG("general pageshow : "+event.originalTarget.location);
	    examplePageLoad(event);
	    }
	    }, false);

    window.addEventListener("pagehide",
	    function (event) {
	    if (FirefoxOnWoozTalk.nbrTab == 1) {
	    LOG("general pagehide "+event.originalTarget.location);
	    examplePageUnload(event);
	    }
	    }, false);

    /* Ouverture d'une nouvelle fenêtre */
    window.addEventListener( "load",
	    function () {
	    LOG("WoozTalk Launch !");

	    var container = getBrowser().tabContainer;
	    container.addEventListener("TabOpen", tabAdded, false);
	    container.addEventListener("TabSelect", tabSelected, false);
	    container.addEventListener("TabClose", tabRemoved, false);

	    addButtons();

	    LOG("Ready");
	    }, false);

    /* Window is closed */
    window.addEventListener( "unload",
	    function () {
	    LOG("WoozTalk unload !");

	    /* Close all sites */
	    closeAllSites(true);

	    var container = getBrowser().tabContainer;
	    container.removeEventListener("TabOpen", tabAdded, false);
	    container.removeEventListener("TabSelect", tabSelected, false);
	    container.removeEventListener("TabClose", tabRemoved, false);

	    SetHasToSendURL(FirefoxOnWoozTalk.isActive);

	    LOG("Windows");
	    if (countWindows() == 0) {
	    unregister_wooztalk();
	    }

	    LOG("WoozTalk Finish (unload) !");
	    return false;
	    }, false);
}
};

FirefoxOnWoozTalk.run_extension();
